/*****************************************************************************
 * $Id: sl-init.c,v 1.1 2005/08/28 13:58:06 killabyte Exp $
 *
 * Elf Backend initialization code.
 *
 * ---------------------------------------------------------------------------
 * pDI-Tools - portable Dynamic Instrumentation Tools
 *   (C) 2004, 2005 Gerardo Garca Pea
 *   Programmed by Gerardo Garca Pea - Inspired on CEPBA DItools
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 *   USA
 *
 *****************************************************************************/

#include<pdiconfig.h>
#include<ebeif.h>
#include<log.h>

int _pdi_solaris_init(void)
{
  /* First of all: get debug info to access ELF data structures */
  if(_pdi_solaris_resolveDebugInfoStruct())
  {
    _pdi_error(THIS, "Runtime Linker debug information cannot be accesed.");
    return -1;
  }

  /* If debug mode is enabled then execute specific checks for this platform */
  if(PDICFG.debug)
    _pdi_solaris_debug_checkSections();

  return 0;
}

