/*****************************************************************************
 * $Id: sl-sfunc.c,v 1.1 2005/08/28 18:48:42 killabyte Exp $
 *
 * The function '_pdi_arch_initSafeFuncs()' get direct pointers to some
 * functions of the C library. Getting this direct pointers (without runtime
 * linker interference) pDI-Tools can work safely without instrument itself.
 *
 * ---------------------------------------------------------------------------
 * pDI-Tools - portable Dynamic Instrumentation Tools
 *   (C) 2004, 2005 Gerardo Garca Pea
 *   Programmed by Gerardo Garca Pea - Inspired on CEPBA DItools
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 *   USA
 *
 *****************************************************************************/

#include<safefunc.h>
#include<ebeif.h>
#include<log.h>
#include<solaris/elfops.h>

int _pdi_solaris_initSafeFuncs(void)
{
  _pdi_safe_fflush   = _pdi_solaris_resolveSymbol("fflush");
  _pdi_safe_fprintf  = _pdi_solaris_resolveSymbol("fprintf");
  _pdi_safe_fputc    = _pdi_solaris_resolveSymbol("fputc");
  _pdi_safe_fputs    = _pdi_solaris_resolveSymbol("fputs");
  _pdi_safe_vfprintf = _pdi_solaris_resolveSymbol("vfprintf");

  return 0;
}

